#include <sys/wait.h>
#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>
#include <ucontext.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

int
main(int argc, char *argv[])
{
  int res;
  int fd;


  // #########################################################
  // On test s'il y a un argument sur la ligne de cœommande pour avoir un message à échanger
  // #########################################################
  //assert(argc == 2);
  if (argc != 3) {
    fprintf(stderr, "Usage %s <nom fifo> \"un_truc\" pour faire passer le message un truc\n", argv[0]);
    exit(2);
  }
  
  fd = open(argv[1], O_WRONLY);
  if (fd <= 0) {
    fprintf(stderr, "probleme avec l'ouverture du fifo %s : %s\n", argv[1], strerror(errno));
    exit(1);
  }
  
  res = write(fd, argv[2], strlen(argv[2])); // envoie de argv[2], le 3ème mot sur la ligne de comande
  if (res == -1) {
    fprintf(stderr, "Erreur pour l'écriture : %s\n", strerror(errno));
    exit(1);
  }

  fprintf(stdout, "Fin de la liaison\n");

  close(fd);

  return 0;
}
